
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

    <title>The first design of Varnish &#8212; Varnish version 6.0.11 documentation</title>
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/classic.css" />
    
    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Varnish - 10 going on 50" href="10goingon50.html" />
    <link rel="prev" title="Going fast slowly" href="thatslow.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="10goingon50.html" title="Varnish - 10 going on 50"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="thatslow.html" title="Going fast slowly"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" accesskey="U">Poul-Hennings random outbursts</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">The first design of Varnish</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <section id="the-first-design-of-varnish">
<span id="phk-firstdesign"></span><h1>The first design of Varnish<a class="headerlink" href="#the-first-design-of-varnish" title="Permalink to this headline">¶</a></h1>
<p>I have been working on a “bit-storage” facility for datamuseum.dk,
and as part of my “eat your own dog-food” policy, I converting my
own personal archive (41 DVD’s worth) as a test.</p>
<p>Along the way I passed through 2006 and found some files from
the birth of Varnish 10 years ago.</p>
<section id="the-first-varnish-design-notes">
<h2>The first Varnish Design notes<a class="headerlink" href="#the-first-varnish-design-notes" title="Permalink to this headline">¶</a></h2>
<p>This file are notes taken during a meeting in Oslo on 2nd feb 2006,
which in essence consisted of Anders Berg cursing Squid for a couple
of hours.</p>
<p>(Originally the meeting was scheduled for jan 24th but a SAS pilot
strike put an end to that.)</p>
<p>To be honest I knew very little about web-traffic, my own homepage
was written in HTML in vi(1), so I had a bit of catching up to do
on that front, but the overall job was pretty simple:  A program
to move bytes … fast.</p>
<p>It is quite interesting to see how many things we got right and
where we kept thinking in the old frame of reference (ie: Squid):</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>Notes on Varnish
----------------

Collected 2006-02-02 to 2006-02-..

Poul-Henning Kamp


Philosophy
----------

It is not enough to deliver a technically superior piece of software,
if it is not possible for people to deploy it usefully in a sensible
way and timely fashion.


Deployment scenarios
--------------------

There are two fundamental usage scenarios for Varnish: when the
first machine is brought up to offload a struggling backend and
when a subsequent machine is brought online to help handle the load.


The first (layer of) Varnish
----------------------------

Somebodys webserver is struggling and they decide to try Varnish.

Often this will be a skunkworks operation with some random PC
purloined from wherever it wasn&#39;t being used and the Varnish &quot;HOWTO&quot;
in one hand.

If they do it in an orderly fashion before things reach panic proportions,
a sensible model is to setup the Varnish box, test it out from your
own browser, see that it answers correctly.  Test it some more and
then add the IP# to the DNS records so that it takes 50% of the load
off the backend.

If it happens as firefighting at 3AM the backend will be moved to another
IP, the Varnish box given the main IP and things had better work real
well, really fast.

In both cases, it would be ideal if all that is necessary to tell
Varnish are two pieces of information:

        Storage location
                Alternatively we can offer an &quot;auto&quot; setting that makes
                Varnish discover what is available and use what it find.

        DNS or IP# of backend.

                IP# is useful when the DNS settings are not quite certain
                or when split DNS horizon setups are used.

Ideally this can be done on the commandline so that there is no
configuration file to edit to get going, just

        varnish -d /home/varnish -s backend.example.dom

and you&#39;re off running.

A text, curses or HTML based based facility to give some instant
feedback and stats is necessary.

If circumstances are not conductive to strucured approach, it should
be possible to repeat this process and set up N independent Varnish
boxes and get some sort of relief without having to read any further
documentation.


The subsequent (layers of) Varnish
----------------------------------

This is what happens once everybody has caught their breath,
and where we start to talk about Varnish clusters.

We can assume that at this point, the already installed Varnish
machines have been configured more precisely and that people
have studied Varnish configuration to some level of detail.

When Varnish machines are put in a cluster, the administrator should
be able to consider the cluster as a unit and not have to think and
interact with the individual nodes.

Some sort of central management node or facility must exist and
it would be preferable if this was not a physical but a logical
entity so that it can follow the admin to the beach.  Ideally it
would give basic functionality in any browser, even mobile phones.

The focus here is scaleability, we want to avoid per-machine
configuration if at all possible.  Ideally, preconfigured hardware
can be plugged into power and net, find an address with DHCP, contact
preconfigured management node, get a configuration and start working.

But we also need to think about how we avoid a site of Varnish
machines from acting like a stampeeding horde when the power or
connectivity is brought back after a disruption.  Some sort of
slow starting (&quot;warm-up&quot; ?) must be implemented to prevent them
from hitting all the backend with the full force.

An important aspect of cluster operations is giving a statistically
meaninful judgement of the cluster size, in particular answering
the question &quot;would adding another machine help ?&quot; precisely.

We should have a facility that allows the administrator to type
in a REGEXP/URL and have all the nodes answer with a checksum, age
and expiry timer for any documents they have which match.  The
results should be grouped by URL and checksum.


Technical concepts
------------------

We want the central Varnish process to be that, just one process, and
we want to keep it small and efficient at all cost.

Code that will not be used for the central functionality should not
be part of the central process.  For instance code to parse, validate
and interpret the (possibly) complex configuration file should be a
separate program.

Depending on the situation, the Varnish process can either invoke
this program via a pipe or receive the ready to use data structures
via a network connection.

Exported data from the Varnish process should be made as cheap as
possible, likely shared memory.  That will allow us to deploy separate
processes for log-grabbing, statistics monitoring and similar
&quot;off-duty&quot; tasks and let the central process get on with the
important job.


Backend interaction
-------------------

We need a way to tune the backend interaction further than what the
HTTP protocol offers out of the box.

We can assume that all documents we get from the backend has an
expiry timer, if not we will set a default timer (configurable of
course).

But we need further policy than that.  Amongst the questions we have
to ask are:

        How long time after the expiry can we serve a cached copy
        of this document while we have reason to believe the backend
        can supply us with an update ?

        How long time after the expiry can we serve a cached copy
        of this document if the backend does not reply or is
        unreachable.

        If we cannot serve this document out of cache and the backend
        cannot inform us, what do we serve instead (404 ?  A default
        document of some sort ?)

        Should we just not serve this page at all if we are in a
        bandwidth crush (DoS/stampede) situation ?

It may also make sense to have a &quot;emergency detector&quot; which triggers
when the backend is overloaded and offer a scaling factor for all
timeouts for when in such an emergency state.  Something like &quot;If
the average response time of the backend rises above 10 seconds,
multiply all expiry timers by two&quot;.

It probably also makes sense to have a bandwidth/request traffic
shaper for backend traffic to prevent any one Varnish machine from
pummeling the backend in case of attacks or misconfigured
expiry headers.


Startup/consistency
-------------------

We need to decide what to do about the cache when the Varnish
process starts.  There may be a difference between it starting
first time after the machine booted and when it is subsequently
(re)started.

By far the easiest thing to do is to disregard the cache, that saves
a lot of code for locating and validating the contents, but this
carries a penalty in backend or cluster fetches whenever a node
comes up.  Lets call this the &quot;transient cache model&quot;

The alternative is to allow persistently cached contents to be used
according to configured criteria:

        Can expired contents be served if we can&#39;t contact the
        backend ?  (dangerous...)

        Can unexpired contents be served if we can&#39;t contact the
        backend ?  If so, how much past the expiry ?

It is a very good question how big a fraction of the persistent
cache would be usable after typical downtimes:

        After a Varnish process restart:  Nearly all.

        After a power-failure ?  Probably at least half, but probably
        not the half that contains the most busy pages.

And we need to take into consideration if validating the format and
contents of the cache might take more resources and time than getting
the content from the backend.

Off the top of my head, I would prefer the transient model any day
because of the simplicity and lack of potential consistency problems,
but if the load on the back end is intolerable this may not be
practically feasible.

The best way to decide is to carefully analyze a number of cold
starts and cache content replacement traces.

The choice we make does affect the storage management part of Varnish,
but I see that is being modular in any instance, so it may merely be
that some storage modules come up clean on any start while other
will come up with existing objects cached.


Clustering
----------

I&#39;m somewhat torn on clustering for traffic purposes.  For admin
and management: Yes, certainly, but starting to pass objects from
one machine in a cluster to another is likely to be just be a waste
of time and code.

Today one can trivially fit 1TB into a 1U machine so the partitioning
argument for cache clusters doesn&#39;t sound particularly urgent to me.

If all machines in the cluster have sufficient cache capacity, the
other remaining argument is backend offloading, that would likely
be better mitigated by implementing a 1:10 style two-layer cluster
with the second level node possibly having twice the storage of
the front row nodes.

The coordination necessary for keeping track of, or discovering in
real-time, who has a given object can easily turn into a traffic
and cpu load nightmare.

And from a performance point of view, it only reduces quality:
First we send out a discovery multicast, then we wait some amount
of time to see if a response arrives only then should we start
to ask the backend for the object.  With a two-level cluster
we can ask the layer-two node right away and if it doesn&#39;t have
the object it can ask the back-end right away, no timeout is
involved in that.

Finally Consider the impact on a cluster of a &quot;must get&quot; object
like an IMG tag with a misspelled URL.  Every hit on the front page
results in one get of the wrong URL.  One machine in the cluster
ask everybody else in the cluster &quot;do you have this URL&quot; every
time somebody gets the frontpage.

If we implement a negative feedback protocol (&quot;No I don&#39;t&quot;), then
each hit on the wrong URL will result in N+1 packets (assuming multicast).

If we use a silent negative protocol the result is less severe for
the machine that got the request, but still everybody wakes up to
to find out that no, we didn&#39;t have that URL.

Negative caching can mitigate this to some extent.


Privacy
-------

Configuration data and instructions passed forth and back should
be encrypted and signed if so configured.  Using PGP keys is
a very tempting and simple solution which would pave the way for
administrators typing a short ascii encoded pgp signed message
into a SMS from their Bahamas beach vacation...


Implementation ideas
--------------------

The simplest storage method mmap(2)&#39;s a disk or file and puts
objects into the virtual memory on page aligned boundaries,
using a small struct for metadata.  Data is not persistant
across reboots.  Object free is incredibly cheap.  Object
allocation should reuse recently freed space if at all possible.
&quot;First free hole&quot; is probably a good allocation strategy.
Sendfile can be used if filebacked.  If nothing else disks
can be used by making a 1-file filesystem on them.

More complex storage methods are object per file and object
in database models.  They are relatively trival and well
understood.  May offer persistence.

Read-Only storage methods may make sense for getting hold
of static emergency contents from CD-ROM etc.

Treat each disk arm as a separate storage unit and keep track of
service time (if possible) to decide storage scheduling.

Avoid regular expressions at runtime.  If config file contains
regexps, compile them into executable code and dlopen() it
into the Varnish process.  Use versioning and refcounts to
do memory management on such segments.

Avoid committing transmit buffer space until we have bandwidth
estimate for client.  One possible way:  Send HTTP header
and time ACKs getting back, then calculate transmit buffer size
and send object.  This makes DoS attacks more harmless and
mitigates traffic stampedes.

Kill all TCP connections after N seconds, nobody waits an hour
for a web-page to load.

Abuse mitigation interface to firewall/traffic shaping:  Allow
the central node to put an IP/Net into traffic shaping or take
it out of traffic shaping firewall rules.  Monitor/interface
process (not main Varnish process) calls script to config
firewalling.

&quot;Warm-up&quot; instructions can take a number of forms and we don&#39;t know
what is the most efficient or most usable.  Here are some ideas:

    Start at these URL&#39;s then...

        ... follow all links down to N levels.

        ... follow all links that match REGEXP no deeper than N levels down.

        ... follow N random links no deeper than M levels down.

        ... load N objects by following random links no deeper than
            M levels down.

    But...

        ... never follow any links that match REGEXP

        ... never pick up objects larger than N bytes

        ... never pick up objects older than T seconds


It makes a lot of sense to not actually implement this in the main
Varnish process, but rather supply a template perl or python script
that primes the cache by requesting the objects through Varnish.
(That would require us to listen separately on 127.0.0.1
so the perlscript can get in touch with Varnish while in warm-up.)

One interesting but quite likely overengineered option in the
cluster case is if the central monitor tracks a fraction of the
requests through the logs of the running machines in the cluster,
spots the hot objects and tell the warming up varnish what objects
to get and from where.


In the cluster configuration, it is probably best to run the cluster
interaction in a separate process rather than the main Varnish
process.  From Varnish to cluster info would go through the shared
memory, but we don&#39;t want to implement locking in the shmem so
some sort of back-channel (UNIX domain or UDP socket ?) is necessary.

If we have such an &quot;supervisor&quot; process, it could also be tasked
with restarting the varnish process if vitals signs fail:  A time
stamp in the shmem or kill -0 $pid.

It may even make sense to run the &quot;supervisor&quot; process in stand
alone mode as well, there it can offer a HTML based interface
to the Varnish process (via shmem).

For cluster use the user would probably just pass an extra argument
when he starts up Varnish:

        varnish -c $cluster_args $other_args
vs

        varnish $other_args

and a &quot;varnish&quot; shell script will Do The Right Thing.


Shared memory
-------------

The shared memory layout needs to be thought about somewhat.  On one
hand we want it to be stable enough to allow people to write programs
or scripts that inspect it, on the other hand doing it entirely in
ascii is both slow and prone to race conditions.

The various different data types in the shared memory can either be
put into one single segment(= 1 file) or into individual segments
(= multiple files).  I don&#39;t think the number of small data types to
be big enough to make the latter impractical.

Storing the &quot;big overview&quot; data in shmem in ASCII or HTML would
allow one to point cat(1) or a browser directly at the mmaped file
with no interpretation necessary, a big plus in my book.

Similarly, if we don&#39;t update them too often, statistics could be stored
in shared memory in perl/awk friendly ascii format.

But the logfile will have to be (one or more) FIFO logs, probably at least
three in fact:  Good requests, Bad requests, and exception messages.

If we decide to make logentries fixed length, we could make them ascii
so that a simple &quot;sort -n /tmp/shmem.log&quot; would put them in order after
a leading numeric timestamp, but it is probably better to provide a
utility to cat/tail-f the log and keep the log in a bytestring FIFO
format.  Overruns should be marked in the output.


*END*
</pre></div>
</div>
</section>
<section id="the-second-varnish-design-notes">
<h2>The second Varnish Design notes<a class="headerlink" href="#the-second-varnish-design-notes" title="Permalink to this headline">¶</a></h2>
<p>You will notice above that there is no mention of VCL, it took a
couple of weeks for that particular lightning to strike.</p>
<p>Interestingly I know exactly where the lightning came from, and
what it hit.</p>
<p>The timeframe was around GCC 4.0.0 which was not their best release,
and I had for some time been pondering a pre-processor for the C
language to make up for the ISO-C stagnation and braindamage.</p>
<p>I’ve read most of the “classic” compiler books, and probably read
more compilers many people (Still to go: <a class="reference external" href="http://datamuseum.dk/wiki/GIER/GA4GuideToDocumentationAndCode">GIER Algol 4</a>) but to be honest I found
them far too theoretical and not very helpful from a <em>practical</em> compiler
construction point of view.</p>
<p>But there is one compiler-book which takes an entirely different
take:  <a class="reference external" href="http://www.amazon.com/gp/search/?field-isbn=0805316701">Hanson and Fraser’s LCC book.</a> which throws LEX and YACC under the truck and
concentrates on compiling.</p>
<p>Taking their low-down approach to parsing, and emitting C code,
there really isn’t much compiler left to write, and I had done
several interesting hacks towards my ‘K’ language.</p>
<p>The lightning rod was all the ideas Anders had for how Varnish
should be able to manipulate the traffic passing through, how
to decide what to cache, how long time to cache it, where to
cache it and … it sounded like a lot of very detailed code
which had to be incredibly configurable.</p>
<p>Soon those two inspiratons collided:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>Notes on Varnish
----------------

Collected 2006-02-24 to 2006-02-..

Poul-Henning Kamp

-----------------------------------------------------------------------
Policy Configuration

Policy is configured in a simple unidirectional (no loops, no goto)
programming language which is compiled into &#39;C&#39; and from there binary
modules which are dlopen&#39;ed by the main Varnish process.

The dl object contains one exported symbol, a pointer to a structure
which contains a reference count, a number of function pointers,
a couple of string variables with identifying information.

All access into the config is protected by the reference counts.

Multiple policy configurations can be loaded at the same time
but only one is the &quot;active configuration&quot;.  Loading, switching and
unloading of policy configurations happen via the managment
process.

A global config sequence number is incremented on each switch and
policy modified object attributes (ttl, cache/nocache) are all
qualified by the config-sequence under which they were calculated
and invalid if a different policy is now in effect.

-----------------------------------------------------------------------
Configuration Language

XXX: include lines.

BNF:
        program:        function
                        | program function

        function:       &quot;sub&quot; function_name compound_statement

        compound_statement:     &quot;{&quot; statements &quot;}&quot;

        statements:     /* empty */
                        | statement
                        | statements statement


        statement:      if_statement
                        | call_statement
                        | &quot;finish&quot;
                        | assignment_statement
                        | action_statement

        if_statement:   &quot;if&quot; condition compound_statement elif_parts else_part

        elif_parts:     /* empty */
                        | elif_part
                        | elif_parts elif_part

        elif_part:      &quot;elseif&quot; condition compound_statement
                        | &quot;elsif&quot; condition compound_statement
                        | &quot;else if&quot; condition compound_statement

        else_part:      /* empty */
                        | &quot;else&quot; compound_statement

        call_statement: &quot;call&quot; function_name

        assign_statement:       field &quot;=&quot; value

        field:          object
                        field &quot;.&quot; variable

        action_statement:       action arguments

        arguments:      /* empty */
                        arguments | argument

-----------------------------------------------------------------------
Sample request policy program

        sub request_policy {

                if (client.ip in 10.0.0.0/8) {
                        no-cache
                        finish
                }

                if (req.url.host ~ &quot;cnn.no$&quot;) {
                        rewrite s/cnn.no$/vg.no/
                }

                if (req.url.path ~ &quot;cgi-bin&quot;) {
                        no-cache
                }

                if (req.useragent ~ &quot;spider&quot;) {
                        no-new-cache
                }

                if (backend.response_time &gt; 0.8s) {
                        set req.ttlfactor = 1.5
                } elseif (backend.response_time &gt; 1.5s) {
                        set req.ttlfactor = 2.0
                } elseif (backend.response_time &gt; 2.5s) {
                        set req.ttlfactor = 5.0
                }

                /*
                 * the program contains no references to
                 * maxage, s-maxage and expires, so the
                 * default handling (RFC2616) applies
                 */
        }

-----------------------------------------------------------------------
Sample fetch policy program

        sub backends {
                set backend.vg.ip = {...}
                set backend.ads.ip = {...}
                set backend.chat.ip = {...}
                set backend.chat.timeout = 10s
                set backend.chat.bandwidth = 2000 MB/s
                set backend.other.ip = {...}
        }

        sub vg_backend {
                set backend.ip = {10.0.0.1-5}
                set backend.timeout = 4s
                set backend.bandwidth = 2000Mb/s
        }

        sub fetch_policy {

                if (req.url.host ~ &quot;/vg.no$/&quot;) {
                        set req.backend = vg
                        call vg_backend
                } else {
                        /* XXX: specify 404 page url ? */
                        error 404
                }

                if (backend.response_time &gt; 2.0s) {
                        if (req.url.path ~ &quot;/landbrugspriser/&quot;) {
                                error 504
                        }
                }
                fetch
                if (backend.down) {
                        if (obj.exist) {
                                set obj.ttl += 10m
                                finish
                        }
                        switch_config ohhshit
                }
                if (obj.result == 404) {
                        error 300 &quot;http://www.vg.no&quot;
                }
                if (obj.result != 200) {
                        finish
                }
                if (obj.size &gt; 256k) {
                        no-cache
                } else if (obj.size &gt; 32k &amp;&amp; obj.ttl &lt; 2m) {
                        obj.tll = 5m
                }
                if (backend.response_time &gt; 2.0s) {
                        set ttl *= 2.0
                }
        }

        sub prefetch_policy {

                if (obj.usage &lt; 10 &amp;&amp; obj.ttl &lt; 5m) {
                        fetch
                }
        }

-----------------------------------------------------------------------
Purging

When a purge request comes in, the regexp is tagged with the next
generation number and added to the tail of the list of purge regexps.

Before a sender transmits an object, it is checked against any
purge-regexps which have higher generation number than the object
and if it matches the request is sent to a fetcher and the object
purged.

If there were purge regexps with higher generation to match, but
they didn&#39;t match, the object is tagged with the current generation
number and moved to the tail of the list.

Otherwise, the object does not change generation number and is
not moved on the generation list.

New Objects are tagged with the current generation number and put
at the tail of the list.

Objects are removed from the generation list when deleted.

When a purge object has a lower generation number than the first
object on the generation list, the purge object has been completed
and will be removed.  A log entry is written with number of compares
and number of hits.

-----------------------------------------------------------------------
Random notes

        swap backed storage

        slowstart by config-flipping
                start-config has peer servers as backend
                once hitrate goes above limit, management process
                flips config to &#39;real&#39; config.

        stat-object
                always URL, not regexp

        management + varnish process in one binary, comms via pipe

        Change from config with long expiry to short expiry, how
        does the ttl drop ?  (config sequence number invalidates
        all calculated/modified attributes.)

        Mgt process holds copy of acceptor socket -&gt;  Restart without
        lost client requests.

        BW limit per client IP: create shortlived object (&lt;4sec)
        to hold status.  Enforce limits by delaying responses.


-----------------------------------------------------------------------
Source structure


        libvarnish
                library with interface facilities, for instance
                functions to open&amp;read shmem log

        varnish
                varnish sources in three classes

-----------------------------------------------------------------------
protocol cluster/mgt/varnish

object_query url -&gt; TTL, size, checksum
{purge,invalidate} regexp
object_status url -&gt; object metadata

load_config filename
switch_config configname
list_configs
unload_config

freeze  # stop the clock, freezes the object store
thaw

suspend # stop acceptor accepting new requests
resume

stop    # forced stop (exits) varnish process
start
restart = &quot;stop;start&quot;

ping $utc_time -&gt; pong $utc_time

# cluster only
config_contents filename $inline -&gt; compilation messages

stats [-mr] -&gt; $data

zero stats

help

-----------------------------------------------------------------------
CLI (local)
        import protocol from above

        telnet localhost someport
        authentication:
                password $secret
        secret stored in {/usr/local}/etc/varnish.secret (400 root:wheel)


-----------------------------------------------------------------------
HTML (local)

        php/cgi-bin thttpd ?
        (alternatively direct from C-code.)
        Everything the CLI can do +
        stats
                popen(&quot;rrdtool&quot;);
        log view

-----------------------------------------------------------------------
CLI (cluster)
        import protocol from above, prefix machine/all
        compound stats
        accept / deny machine (?)
        curses if you set termtype

-----------------------------------------------------------------------
HTML (cluster)
        ditto
        ditto

        http://clustercontrol/purge?regexp=fslkdjfslkfdj
                POST with list of regexp
                authentication ? (IP access list)

-----------------------------------------------------------------------
Mail (cluster)

        pgp signed emails with CLI commands

-----------------------------------------------------------------------
connection varnish -&gt; cluster controller

        Encryption
                SSL
        Authentication (?)
                IP number checks.

        varnish -c clusterid -C mycluster_ctrl.vg.no

-----------------------------------------------------------------------
Filer
        /usr/local/sbin/varnish
                contains mgt + varnish process.
                if -C argument, open SSL to cluster controller.
                Arguments:
                        -p portnumber
                        -c clusterid@cluster_controller
                        -f config_file
                        -m memory_limit
                        -s kind[,storage-options]
                        -l logfile,logsize
                        -b backend ip...
                        -d debug
                        -u uid
                        -a CLI_port

                KILL SIGTERM    -&gt; suspend, stop

        /usr/local/sbin/varnish_cluster
                Cluster controller.
                Use syslog

                Arguments:
                        -f config file
                        -d debug
                        -u uid (?)

        /usr/local/sbin/varnish_logger
                Logfile processor
                -i shmemfile
                -e regexp
                -o &quot;/var/log/varnish.%Y%m%d.traffic&quot;
                -e regexp2
                -n &quot;/var/log/varnish.%Y%m%d.exception&quot;  (NCSA format)
                -e regexp3
                -s syslog_level,syslogfacility
                -r host:port    send via TCP, prefix hostname

                SIGHUP: reopen all files.

        /usr/local/bin/varnish_cli
                Command line tool.

        /usr/local/share/varnish/etc/varnish.conf
                default request + fetch + backend scripts

        /usr/local/share/varnish/etc/rfc2616.conf
                RFC2616 compliant handling function

        /usr/local/etc/varnish.conf (optional)
                request + fetch + backend scripts

        /usr/local/share/varnish/etc/varnish.startup
                default startup sequence

        /usr/local/etc/varnish.startup (optional)
                startup sequence

        /usr/local/etc/varnish_cluster.conf
                XXX

        {/usr/local}/etc/varnish.secret
                CLI password file.

-----------------------------------------------------------------------
varnish.startup

        load config /foo/bar startup_conf
        switch config startup_conf
        !mypreloadscript
        load config /foo/real real_conf
        switch config real_conf
        resume
</pre></div>
</div>
</section>
<section id="the-third-varnish-design-notes">
<h2>The third Varnish Design notes<a class="headerlink" href="#the-third-varnish-design-notes" title="Permalink to this headline">¶</a></h2>
<p>A couple of days later the ideas had gel’ed:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>Notes on Varnish
----------------

Collected 2006-02-26 to 2006-03-..

Poul-Henning Kamp

-----------------------------------------------------------------------

Objects available to functions in VCL

        client  # The client

        req     # The request

        obj     # The object from which we satisfy it

        backend # The chosen supplier

-----------------------------------------------------------------------
Configuration Language

XXX: declare IP lists ?

BNF:
        program:        part
                        | program part

        part:           &quot;sub&quot; function_name compound
                        | &quot;backend&quot; backend_name compound

        compound:       &quot;{&quot; statements &quot;}&quot;

        statements:     /* empty */
                        | statement
                        | statements statement

        statement:      conditional
                        | functioncall
                        | &quot;set&quot; field value
                        | field &quot;=&quot; value
                        | &quot;no_cache&quot;
                        | &quot;finish&quot;
                        | &quot;no_new_cache&quot;
                        | call function_name
                        | fetch
                        | error status_code
                        | error status_code string(message)
                        | switch_config config_id
                        | rewrite field string(match) string(replace)

        conditional:    &quot;if&quot; condition compound elif_parts else_part

        elif_parts:     /* empty */
                        | elif_part
                        | elif_parts elif_part

        elif_part:      &quot;elseif&quot; condition compound
                        | &quot;elsif&quot; condition compound
                        | &quot;else if&quot; condition compound

        else_part:      /* empty */
                        | &quot;else&quot; compound

        functioncal:    &quot;call&quot; function_name

        field:          object
                        field &quot;.&quot; variable

        condition:      &#39;(&#39; cond_or &#39;)&#39;

        cond_or:        cond_and
                        | cond_or &#39;||&#39; cond_and

        cond_and:       cond_part
                        | cond_and &#39;&amp;&amp;&#39; cond_part

        cond_part:      &#39;!&#39; cond_part2
                        | cond_part2

        cond_part2:     condition
                        | field(int) &#39;&lt;&#39; number
                        | field(int) &#39;&lt;=&#39; number
                        | field(int) &#39;&gt;&#39; number
                        | field(int) &#39;&gt;=&#39; number
                        | field(int) &#39;=&#39; number
                        | field(int) &#39;!=&#39; number
                        | field(IP)  ~ ip_list
                        | field(string) ~ string(regexp)

-----------------------------------------------------------------------
Sample request policy program

        sub request_policy {

                if (client.ip in 10.0.0.0/8) {
                        no-cache
                        finish
                }

                if (req.url.host ~ &quot;cnn.no$&quot;) {
                        rewrite s/cnn.no$/vg.no/
                }

                if (req.url.path ~ &quot;cgi-bin&quot;) {
                        no-cache
                }

                if (req.useragent ~ &quot;spider&quot;) {
                        no-new-cache
                }

                if (backend.response_time &gt; 0.8s) {
                        set req.ttlfactor = 1.5
                } elseif (backend.response_time &gt; 1.5s) {
                        set req.ttlfactor = 2.0
                } elseif (backend.response_time &gt; 2.5s) {
                        set req.ttlfactor = 5.0
                }

                /*
                 * the program contains no references to
                 * maxage, s-maxage and expires, so the
                 * default handling (RFC2616) applies
                 */
        }

-----------------------------------------------------------------------
Sample fetch policy program

        sub backends {
                set backend.vg.ip = {...}
                set backend.ads.ip = {...}
                set backend.chat.ip = {...}
                set backend.chat.timeout = 10s
                set backend.chat.bandwidth = 2000 MB/s
                set backend.other.ip = {...}
        }

        sub vg_backend {
                set backend.ip = {10.0.0.1-5}
                set backend.timeout = 4s
                set backend.bandwidth = 2000Mb/s
        }

        sub fetch_policy {

                if (req.url.host ~ &quot;/vg.no$/&quot;) {
                        set req.backend = vg
                        call vg_backend
                } else {
                        /* XXX: specify 404 page url ? */
                        error 404
                }

                if (backend.response_time &gt; 2.0s) {
                        if (req.url.path ~ &quot;/landbrugspriser/&quot;) {
                                error 504
                        }
                }
                fetch
                if (backend.down) {
                        if (obj.exist) {
                                set obj.ttl += 10m
                                finish
                        }
                        switch_config ohhshit
                }
                if (obj.result == 404) {
                        error 300 &quot;http://www.vg.no&quot;
                }
                if (obj.result != 200) {
                        finish
                }
                if (obj.size &gt; 256k) {
                        no-cache
                } else if (obj.size &gt; 32k &amp;&amp; obj.ttl &lt; 2m) {
                        obj.tll = 5m
                }
                if (backend.response_time &gt; 2.0s) {
                        set ttl *= 2.0
                }
        }

        sub prefetch_policy {

                if (obj.usage &lt; 10 &amp;&amp; obj.ttl &lt; 5m) {
                        fetch
                }
        }

-----------------------------------------------------------------------
Purging

When a purge request comes in, the regexp is tagged with the next
generation number and added to the tail of the list of purge regexps.

Before a sender transmits an object, it is checked against any
purge-regexps which have higher generation number than the object
and if it matches the request is sent to a fetcher and the object
purged.

If there were purge regexps with higher generation to match, but
they didn&#39;t match, the object is tagged with the current generation
number and moved to the tail of the list.

Otherwise, the object does not change generation number and is
not moved on the generation list.

New Objects are tagged with the current generation number and put
at the tail of the list.

Objects are removed from the generation list when deleted.

When a purge object has a lower generation number than the first
object on the generation list, the purge object has been completed
and will be removed.  A log entry is written with number of compares
and number of hits.

-----------------------------------------------------------------------
Random notes

        swap backed storage

        slowstart by config-flipping
                start-config has peer servers as backend
                once hitrate goes above limit, management process
                flips config to &#39;real&#39; config.

        stat-object
                always URL, not regexp

        management + varnish process in one binary, comms via pipe

        Change from config with long expiry to short expiry, how
        does the ttl drop ?  (config sequence number invalidates
        all calculated/modified attributes.)

        Mgt process holds copy of acceptor socket -&gt;  Restart without
        lost client requests.

        BW limit per client IP: create shortlived object (&lt;4sec)
        to hold status.  Enforce limits by delaying responses.


-----------------------------------------------------------------------
Source structure


        libvarnish
                library with interface facilities, for instance
                functions to open&amp;read shmem log

        varnish
                varnish sources in three classes

-----------------------------------------------------------------------
protocol cluster/mgt/varnish

object_query url -&gt; TTL, size, checksum
{purge,invalidate} regexp
object_status url -&gt; object metadata

load_config filename
switch_config configname
list_configs
unload_config

freeze  # stop the clock, freezes the object store
thaw

suspend # stop acceptor accepting new requests
resume

stop    # forced stop (exits) varnish process
start
restart = &quot;stop;start&quot;

ping $utc_time -&gt; pong $utc_time

# cluster only
config_contents filename $inline -&gt; compilation messages

stats [-mr] -&gt; $data

zero stats

help

-----------------------------------------------------------------------
CLI (local)
        import protocol from above

        telnet localhost someport
        authentication:
                password $secret
        secret stored in {/usr/local}/etc/varnish.secret (400 root:wheel)


-----------------------------------------------------------------------
HTML (local)

        php/cgi-bin thttpd ?
        (alternatively direct from C-code.)
        Everything the CLI can do +
        stats
                popen(&quot;rrdtool&quot;);
        log view

-----------------------------------------------------------------------
CLI (cluster)
        import protocol from above, prefix machine/all
        compound stats
        accept / deny machine (?)
        curses if you set termtype

-----------------------------------------------------------------------
HTML (cluster)
        ditto
        ditto

        http://clustercontrol/purge?regexp=fslkdjfslkfdj
                POST with list of regexp
                authentication ? (IP access list)

-----------------------------------------------------------------------
Mail (cluster)

        pgp signed emails with CLI commands

-----------------------------------------------------------------------
connection varnish -&gt; cluster controller

        Encryption
                SSL
        Authentication (?)
                IP number checks.

        varnish -c clusterid -C mycluster_ctrl.vg.no

-----------------------------------------------------------------------
Filer
        /usr/local/sbin/varnish
                contains mgt + varnish process.
                if -C argument, open SSL to cluster controller.
                Arguments:
                        -p portnumber
                        -c clusterid@cluster_controller
                        -f config_file
                        -m memory_limit
                        -s kind[,storage-options]
                        -l logfile,logsize
                        -b backend ip...
                        -d debug
                        -u uid
                        -a CLI_port

                KILL SIGTERM    -&gt; suspend, stop

        /usr/local/sbin/varnish_cluster
                Cluster controller.
                Use syslog

                Arguments:
                        -f config file
                        -d debug
                        -u uid (?)

        /usr/local/sbin/varnish_logger
                Logfile processor
                -i shmemfile
                -e regexp
                -o &quot;/var/log/varnish.%Y%m%d.traffic&quot;
                -e regexp2
                -n &quot;/var/log/varnish.%Y%m%d.exception&quot;  (NCSA format)
                -e regexp3
                -s syslog_level,syslogfacility
                -r host:port    send via TCP, prefix hostname

                SIGHUP: reopen all files.

        /usr/local/bin/varnish_cli
                Command line tool.

        /usr/local/share/varnish/etc/varnish.conf
                default request + fetch + backend scripts

        /usr/local/share/varnish/etc/rfc2616.conf
                RFC2616 compliant handling function

        /usr/local/etc/varnish.conf (optional)
                request + fetch + backend scripts

        /usr/local/share/varnish/etc/varnish.startup
                default startup sequence

        /usr/local/etc/varnish.startup (optional)
                startup sequence

        /usr/local/etc/varnish_cluster.conf
                XXX

        {/usr/local}/etc/varnish.secret
                CLI password file.

-----------------------------------------------------------------------
varnish.startup

        load config /foo/bar startup_conf
        switch config startup_conf
        !mypreloadscript
        load config /foo/real real_conf
        switch config real_conf
        resume
</pre></div>
</div>
</section>
<section id="fourth-varnish-design-note">
<h2>Fourth Varnish Design Note<a class="headerlink" href="#fourth-varnish-design-note" title="Permalink to this headline">¶</a></h2>
<p>You’d think we’d be cookin’ with gas now, and indeed we were, but now
all the difficult details started to raise ugly questions, and it
has never stopped since:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>Questions:

*  Which &quot;Host:&quot; do we put in the request to the backend ?

      The one we got from the client ?

      The ip/dns-name of the backend ?

      Configurable in VCL backend declaration ?

      (test with www.ing.dk)

*  Construction of headers for queries to backend ?

      How much do we take from client headers, how much do we make up ?

      Some sites discriminate contents based on User-Agent header.
         (test with www.krak.dk/www.rs-components.dk)

      Cookies

*  Mapping of headers from backend reply to the reply to client

      Which fields come from the backend ?

      Which fields are made up on the spot ? (expiry time ?)

      (Static header fields can be prepended to contents in storage)


*  3xx replies from the backend

      Does varnish follow a redirection or do we pass it to the client ?

      Do we cache 3xx replies ?
</pre></div>
</div>
</section>
<section id="the-first-live-traffic">
<h2>The first live traffic<a class="headerlink" href="#the-first-live-traffic" title="Permalink to this headline">¶</a></h2>
<p>The final bit of history I want to share is the IRC log from the
first time tried to put real live traffic through Varnish.</p>
<p>The language is interscandinavian, but I think non-vikings can get
still get the drift:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span>**** BEGIN LOGGING AT Thu Jul  6 12:36:48 2006

Jul 06 12:36:48 *       Now talking on #varnish
Jul 06 12:36:48 *       EvilDES gives channel operator status to andersb
Jul 06 12:36:53 *       EvilDES gives channel operator status to phk
Jul 06 12:36:53 &lt;andersb&gt;       hehe
Jul 06 12:36:56 &lt;EvilDES&gt;       sånn
Jul 06 12:37:00 &lt;andersb&gt;       Jepps, er dere klare?
Jul 06 12:37:08 &lt;phk&gt;   Jeg har varnish oppe og køre med leonora som backend.
Jul 06 12:37:12 *       EvilDES has changed the topic to: Live testing in progress!
Jul 06 12:37:16 *       EvilDES sets mode +t #varnish
Jul 06 12:37:19 &lt;andersb&gt;       Da setter jeg på trafikk
Jul 06 12:37:36 &lt;phk&gt;   andersb: kan du starte med bare at give us trafiik i 10 sekunder eller så ?
Jul 06 12:37:49 *       edward (edward@f95.linpro.no) has joined #varnish
Jul 06 12:38:32 &lt;andersb&gt;       hmm, først må jeg få trafikk dit.
Jul 06 12:38:55 &lt;andersb&gt;       Har noe kommet? Eller har det blitt suprt etter /systemmeldinger/h.html som er helsefilen?
Jul 06 12:39:10 &lt;andersb&gt;       s/suprt/spurt/
Jul 06 12:39:41 &lt;EvilDES&gt;       ser ingenting
Jul 06 12:39:45 &lt;phk&gt;   jeg har ikke set noget endnu...
Jul 06 12:40:35 &lt;phk&gt;   den prøver på port 80
Jul 06 12:41:24 &lt;andersb&gt;       okay..
Jul 06 12:41:31 &lt;EvilDES&gt;       kan vi ikke bare kjøre varnishd på port 80?
Jul 06 12:41:46 &lt;phk&gt;   ok, jeg ville bare helst ikke køre som root.
Jul 06 12:41:47 &lt;andersb&gt;       Prøver den noe annet nå?
Jul 06 12:41:59 &lt;phk&gt;   nej stadig 80.
Jul 06 12:42:03 &lt;phk&gt;   Jeg starter varnishd som root
Jul 06 12:42:08 &lt;EvilDES&gt;       nei, vent
Jul 06 12:42:08 &lt;andersb&gt;       Topp
Jul 06 12:42:11 &lt;andersb&gt;       okay
Jul 06 12:42:15 &lt;andersb&gt;       kom det 8080 nå?
Jul 06 12:42:18 &lt;EvilDES&gt;       sysctl reserved_port
Jul 06 12:43:04 &lt;andersb&gt;       okay? Får dere 8080 trafikk nå?
Jul 06 12:43:08 &lt;EvilDES&gt;       sysctl net.inet.ip.portrange.reservedhigh=79
Jul 06 12:44:41 &lt;andersb&gt;       Okay, avventer om vi skal kjøre 8080 eller 80.
Jul 06 12:45:56 &lt;EvilDES&gt;       starter den på port 80 som root
Jul 06 12:46:01 &lt;phk&gt;   den kører nu
Jul 06 12:46:01 &lt;andersb&gt;       Okay, vi har funnet ut at måten jeg satte 8080 på i lastbalanserern var feil.
Jul 06 12:46:07 &lt;andersb&gt;       okay på 80?
Jul 06 12:46:12 &lt;phk&gt;   vi kører
Jul 06 12:46:14 &lt;EvilDES&gt;       ja, masse trafikk
Jul 06 12:46:29 &lt;phk&gt;   omtrent 100 req/sec
Jul 06 12:46:37 &lt;phk&gt;   and we&#39;re dead...
Jul 06 12:46:40 &lt;EvilDES&gt;       stopp!
Jul 06 12:46:58 &lt;andersb&gt;       den stopper automatisk.
Jul 06 12:47:04 &lt;andersb&gt;       Vi kan bare kjøre det slik.
Jul 06 12:47:06 &lt;EvilDES&gt;       tok noen sekunder
Jul 06 12:47:20 &lt;andersb&gt;       Npr den begynner svar på 80 så vil lastbalanserern finne den fort og sende trafikk.
Jul 06 12:47:41 &lt;EvilDES&gt;       ca 1500 connection requests kom inn før den sluttet å sende oss trafikk
Jul 06 12:47:49 &lt;EvilDES&gt;       altså, 1500 etter at varnishd døde
Jul 06 12:48:02 &lt;andersb&gt;       tror det er en god nok måte å gjøre det på. Så slipper vi å configge hele tiden.
Jul 06 12:48:07 &lt;EvilDES&gt;       greit
Jul 06 12:48:11 &lt;EvilDES&gt;       det er dine lesere :)
Jul 06 12:48:19 &lt;andersb&gt;       ja :)
Jul 06 12:48:35 &lt;andersb&gt;       kan sette ned retry raten litt.
Jul 06 12:49:15 &lt;andersb&gt;       &gt;&gt; AS3408-2 VG Nett - Real server 21 # retry
Jul 06 12:49:16 &lt;andersb&gt;       Current number of failure retries: 4
Jul 06 12:49:16 &lt;andersb&gt;       Enter new number of failure retries [1-63]: 1
Jul 06 12:49:33 &lt;andersb&gt;       ^^ before de decalres dead
Jul 06 12:49:41 &lt;andersb&gt;       he declairs :)
Jul 06 12:51:45 &lt;phk&gt;   I&#39;ve saved the core, lets try again for another shot.
Jul 06 12:52:09 &lt;andersb&gt;       sure :)
Jul 06 12:52:34 &lt;andersb&gt;       When you start port 80 loadbalancer will send 8 req&#39;s for h.html then start gicing traficc
Jul 06 12:53:00 &lt;andersb&gt;       ^^ Microsoft keyboard
Jul 06 12:53:09 &lt;phk&gt;   ok, jeg starter
Jul 06 12:53:10 &lt;EvilDES&gt;       you need to get a Linux keyboard
Jul 06 12:53:16 &lt;andersb&gt;       Yeah :)
Jul 06 12:53:18 &lt;EvilDES&gt;       woo!
Jul 06 12:53:21 &lt;phk&gt;   boom.
Jul 06 12:53:25 &lt;EvilDES&gt;       oops
Jul 06 12:53:35 &lt;EvilDES&gt;       18 connections, 77 requests
Jul 06 12:53:40 &lt;EvilDES&gt;       that didn&#39;t last long...
Jul 06 12:54:41 &lt;andersb&gt;       longer than me :) *rude joke
Jul 06 12:55:04 &lt;phk&gt;   bewm
Jul 06 12:55:22 &lt;andersb&gt;       can I follow a log?
Jul 06 12:55:39 &lt;andersb&gt;       with: lt-varnishlog ?
Jul 06 12:56:27 &lt;phk&gt;   samme fejl
Jul 06 12:56:38 &lt;phk&gt;   andersb: jeg gemmer logfilerne
Jul 06 12:57:00 &lt;phk&gt;   bewm
Jul 06 12:57:13 &lt;andersb&gt;       phk: Jepp, men for min egen del for å se når dere skrur på etc. Da lærer jeg loadbalancer ting.
Jul 06 12:57:51 &lt;phk&gt;   ok, samme fejl igen.
Jul 06 12:58:02 &lt;phk&gt;   jeg foreslår vi holder en lille pause mens jeg debugger.
Jul 06 12:58:09 &lt;andersb&gt;       sure.
Jul 06 12:58:16 &lt;EvilDES&gt;       andersb: cd ~varnish/varnish/trunk/varnish-cache/bin/varnishlog
Jul 06 12:58:21 &lt;EvilDES&gt;       andersb: ./varnishlog -o
Jul 06 12:58:37 &lt;EvilDES&gt;       andersb: cd ~varnish/varnish/trunk/varnish-cache/bin/varnishstat
Jul 06 12:58:43 &lt;EvilDES&gt;       andersb: ./varnishstat -c
Jul 06 12:58:44 &lt;phk&gt;   eller ./varnislog -r _vlog3 -o | less
Jul 06 13:00:02 &lt;andersb&gt;       Jeg går meg en kort tur. Straks tilbake.
Jul 06 13:01:27 &lt;phk&gt;   vi kører igen
Jul 06 13:02:31 &lt;phk&gt;   2k requests
Jul 06 13:02:57 &lt;phk&gt;   3k
Jul 06 13:03:39 &lt;phk&gt;   5k
Jul 06 13:03:55 &lt;EvilDES&gt;       ser veldig bra ut
Jul 06 13:04:06 &lt;EvilDES&gt;       hit rate &gt; 93%
Jul 06 13:04:13 &lt;EvilDES&gt;       95%
Jul 06 13:05:14 &lt;phk&gt;   800 objects
Jul 06 13:05:32 &lt;EvilDES&gt;       load 0.28
Jul 06 13:05:37 &lt;EvilDES&gt;       0.22
Jul 06 13:05:52 &lt;EvilDES&gt;       CPU 98.9% idle :)
Jul 06 13:06:12 &lt;phk&gt;   4-5 Mbit/sec
Jul 06 13:06:42 &lt;andersb&gt;       nice :)
Jul 06 13:06:49 &lt;andersb&gt;       vi kjører til det krasjer?
Jul 06 13:06:58 &lt;phk&gt;   jep
Jul 06 13:07:05 &lt;phk&gt;   du må gerne åbne lidt mere
Jul 06 13:07:20 &lt;andersb&gt;       okay
Jul 06 13:07:41 &lt;andersb&gt;       3 ganger mer...
Jul 06 13:08:04 &lt;andersb&gt;       si fra når dere vil ha mer.
Jul 06 13:08:24 &lt;phk&gt;   vi gir den lige et par minutter på det her niveau
Jul 06 13:09:17 &lt;phk&gt;   bewm
Jul 06 13:09:31 &lt;EvilDES&gt;               3351        0.00 Client connections accepted
Jul 06 13:09:31 &lt;EvilDES&gt;              23159        0.00 Client requests received
Jul 06 13:09:31 &lt;EvilDES&gt;              21505        0.00 Cache hits
Jul 06 13:09:31 &lt;EvilDES&gt;               1652        0.00 Cache misses
Jul 06 13:10:17 &lt;phk&gt;   kører igen
Jul 06 13:10:19 &lt;EvilDES&gt;       here we go again
Jul 06 13:11:06 &lt;phk&gt;   20mbit/sec
Jul 06 13:11:09 &lt;phk&gt;   100 req/sec
Jul 06 13:12:30 &lt;andersb&gt;       nice :)
Jul 06 13:12:46 &lt;andersb&gt;       det er gode tall, og jeg skal fortelle dere hvorfor senere
Jul 06 13:12:49 &lt;phk&gt;   steady 6-8 mbit/sec
Jul 06 13:12:52 &lt;andersb&gt;       okay.
Jul 06 13:13:00 &lt;phk&gt;   ca 50 req/sec
Jul 06 13:13:04 &lt;EvilDES&gt;       skal vi øke?
Jul 06 13:13:14 &lt;phk&gt;   ja, giv den det dobbelte hvis du kan
Jul 06 13:13:19 &lt;andersb&gt;       vi startet med 1 -&gt; 3 -&gt; ?
Jul 06 13:13:22 &lt;phk&gt;   6
Jul 06 13:13:23 &lt;andersb&gt;       6
Jul 06 13:13:34 &lt;andersb&gt;       done
Jul 06 13:13:42 &lt;andersb&gt;       den hopper opp graceful.
Jul 06 13:13:54 &lt;EvilDES&gt;       boom
Jul 06 13:14:06 &lt;andersb&gt;       :)
Jul 06 13:14:11 &lt;EvilDES&gt;       men ingen ytelsesproblemer
Jul 06 13:14:19 &lt;EvilDES&gt;       bare bugs i requestparsering
Jul 06 13:14:20 &lt;phk&gt;   kører igen
Jul 06 13:14:26 &lt;phk&gt;   bewm
Jul 06 13:14:31 &lt;phk&gt;   ok, vi pauser lige...
Jul 06 13:17:40 &lt;phk&gt;   jeg har et problem med &quot;pass&quot; requests, det skal jeg lige have fundet inden vi går videre.
Jul 06 13:18:51 &lt;andersb&gt;       Sure.
Jul 06 13:28:50 &lt;phk&gt;   ok, vi prøver igen
Jul 06 13:29:09 &lt;phk&gt;   bewm
Jul 06 13:29:35 &lt;phk&gt;   more debugging
Jul 06 13:33:56 &lt;phk&gt;   OK, found the/one pass-mode bug
Jul 06 13:33:58 &lt;phk&gt;   trying again
Jul 06 13:35:23 &lt;phk&gt;   150 req/s 24mbit/s, still alive
Jul 06 13:37:02 &lt;EvilDES&gt;       andersb: tror du du klarer å komme deg hit til foredraget, eller er du helt ødelagt?
Jul 06 13:37:06 &lt;phk&gt;   andersb: giv den 50% mere trafik
Jul 06 13:39:46 &lt;andersb&gt;       mer trafikk
Jul 06 13:39:56 &lt;andersb&gt;       EvilDES: Nei :(( Men Stein fra VG Nett kommer.
Jul 06 13:41:25 &lt;EvilDES&gt;       btw, har du noen data om hva load balanceren synes om varnish?
Jul 06 13:41:50 &lt;EvilDES&gt;       jeg regner med at den følger med litt på hvor god jobb vi gjør
Jul 06 13:43:10 &lt;phk&gt;   Jeg genstarter lige med flere workerthreads...
Jul 06 13:43:43 &lt;phk&gt;   jeg tror 20 workerthreads var for lidt nu...
Jul 06 13:43:47 &lt;phk&gt;   nu har den 220
Jul 06 13:44:40 &lt;EvilDES&gt;               2976      107.89 Client connections accepted
Jul 06 13:44:41 &lt;EvilDES&gt;              10748      409.57 Client requests received
Jul 06 13:44:41 &lt;EvilDES&gt;               9915      389.59 Cache hits
Jul 06 13:45:13 &lt;EvilDES&gt;       det var altså 400 i sekundet :)
Jul 06 13:45:45 &lt;phk&gt;   og ingen indlysende fejl på www.vg.no siden :-)
Jul 06 13:45:54 &lt;phk&gt;   bewm
Jul 06 13:47:16 &lt;EvilDES&gt;       andersb: hvor stor andel av trafikken hadde vi nå?
Jul 06 13:48:06 &lt;EvilDES&gt;       altså, vekt i load balanceren i forhold til totalen
Jul 06 13:49:20 &lt;phk&gt;   ok, kun 120 threads så...
Jul 06 13:50:48 &lt;andersb&gt;       9
Jul 06 13:52:45 &lt;phk&gt;   andersb: 9 -&gt; 12 ?
Jul 06 13:52:48 &lt;EvilDES&gt;       andersb: 9 til varnish, men hvor mye er den totale vekten?
Jul 06 13:52:58 &lt;EvilDES&gt;       har vi 1%? 5%? 10%?
Jul 06 13:54:37 &lt;EvilDES&gt;       nå passerte vi nettopp 50000 requests uten kræsj
Jul 06 13:55:36 &lt;phk&gt;   maskinen laver ingenting...  98.5% idle
Jul 06 13:56:21 &lt;andersb&gt;       12 maskiner med weight 20
Jul 06 13:56:26 &lt;andersb&gt;       1 med weight 40
Jul 06 13:56:29 &lt;andersb&gt;       varnish med 9
Jul 06 13:57:01 &lt;andersb&gt;       si fra når dere vil ha mer trafikk.
Jul 06 13:57:02 &lt;phk&gt;   9/289 = 3.1%
Jul 06 13:57:12 &lt;phk&gt;   andersb: giv den 15
Jul 06 13:57:44 &lt;andersb&gt;       gjort
Jul 06 13:59:43 &lt;andersb&gt;       dette er morro. Jeg må si det.
Jul 06 14:00:27 &lt;phk&gt;   20-23 Mbit/sec steady, 200 req/sec, 92.9% idle
Jul 06 14:00:30 &lt;phk&gt;   bewm
Jul 06 14:00:46 &lt;EvilDES&gt;       OK
Jul 06 14:00:57 &lt;EvilDES&gt;       jeg tror vi kan slå fast at ytelsen er som den skal være
Jul 06 14:01:33 &lt;EvilDES&gt;       det er en del bugs, men de bør det gå an å fikse.
Jul 06 14:01:34 &lt;andersb&gt;       Jepp :) Det så pent ut...
Jul 06 14:01:53 &lt;phk&gt;   jeg tror ikke vi har set skyggen af hvad Varnish kan yde endnu...
Jul 06 14:01:53 &lt;EvilDES&gt;       andersb: hvordan ligger vi an i forhold til Squid?
Jul 06 14:01:58 &lt;andersb&gt;       pent :)
Jul 06 14:02:13 &lt;andersb&gt;       Jeg har ikke fått SNMP opp på dene boksen, jeg burde grafe det...
Jul 06 14:02:23 &lt;EvilDES&gt;       snmp kjører på c21
Jul 06 14:02:33 &lt;EvilDES&gt;       tror agero satte det opp
Jul 06 14:02:36 &lt;EvilDES&gt;       aagero
Jul 06 14:02:38 &lt;andersb&gt;       Ja, men jeg har ikke mal i cacti for bsnmpd
Jul 06 14:02:43 &lt;EvilDES&gt;       ah, ok
Jul 06 14:03:03 &lt;EvilDES&gt;       men den burde støtte standard v2 mib?
Jul 06 14:03:26 &lt;andersb&gt;       det er ikke protocoll feil :)
Jul 06 14:03:42 &lt;andersb&gt;       Hva er byte hitratio forresetn?
Jul 06 14:03:52 &lt;EvilDES&gt;       det tror jeg ikke vi måler
Jul 06 14:03:55 &lt;EvilDES&gt;       enda
Jul 06 14:03:59 &lt;phk&gt;   andersb: den har jeg ikke stats på endnu.
Jul 06 14:04:22 &lt;phk&gt;   ok, forrige crash ligner en 4k+ HTTP header...
Jul 06 14:04:27 &lt;phk&gt;   (eller en kodefejl)
Jul 06 14:06:03 &lt;phk&gt;   andersb: prøv at øge vores andel til 20
Jul 06 14:06:26 &lt;EvilDES&gt;       hvilken vekt har hver av de andre cachene?
Jul 06 14:06:49 &lt;phk&gt;   20 og en med 40
Jul 06 14:07:50 &lt;andersb&gt;       gjort
Jul 06 14:08:59 &lt;phk&gt;   440 req/s 43mbit/s
Jul 06 14:09:17 &lt;phk&gt;   bewm
Jul 06 14:09:18 &lt;EvilDES&gt;       bewm
Jul 06 14:10:30 &lt;EvilDES&gt;       oj
Jul 06 14:10:39 &lt;EvilDES&gt;       vi var oppe over 800 req/s et øyeblikk
Jul 06 14:10:46 &lt;phk&gt;   60mbit/sec
Jul 06 14:10:52 &lt;phk&gt;   og 90% idle :-)
Jul 06 14:10:59 &lt;EvilDES&gt;       ingen swapping
Jul 06 14:11:58 &lt;EvilDES&gt;       og vi bruker nesten ikke noe minne - 3 GB ledig fysisk RAM
Jul 06 14:13:02 &lt;phk&gt;   ca 60 syscall / req
Jul 06 14:14:31 &lt;andersb&gt;       nice :)
Jul 06 14:14:58 &lt;phk&gt;   andersb: prøv at give os 40
Jul 06 14:17:26 &lt;andersb&gt;       gjort
Jul 06 14:18:17 &lt;phk&gt;   det ligner at trafikken falder her sidst på eftermiddagen...
Jul 06 14:19:07 &lt;andersb&gt;       ja :)
Jul 06 14:19:43 &lt;phk&gt;   andersb: så skal vi nok ikke øge mere, nu nærmer vi os hvad 100Mbit ethernet kan klare.
Jul 06 14:19:58 &lt;andersb&gt;       bra :)
Jul 06 14:20:36 &lt;phk&gt;   42mbit/s steady
Jul 06 14:20:59 &lt;EvilDES&gt;       40 av 320?
Jul 06 14:21:06 &lt;EvilDES&gt;       12,5%
Jul 06 14:21:43 *       nicholas (nicholas@nfsd.linpro.no) has joined #varnish
Jul 06 14:22:00 &lt;phk&gt;   det der cluster-noget bliver der da ikke brug for når vi har 87% idle
Jul 06 14:23:05 &lt;andersb&gt;       hehe :)
Jul 06 14:24:38 &lt;andersb&gt;       skal stille de andre ned litt for 48 er max
Jul 06 14:24:57 &lt;phk&gt;   jeg tror ikke vi skal gå højere før vi har gigE
Jul 06 14:25:14 &lt;andersb&gt;       4-5MB/s
Jul 06 14:25:32 &lt;andersb&gt;       lastbalanserer backer off på 100 Mbit
Jul 06 14:25:35 &lt;andersb&gt;       :)
Jul 06 14:25:42 &lt;andersb&gt;       Så vi kan kjøre nesten til taket.
Jul 06 14:26:01 &lt;andersb&gt;       hvis det har noe poeng.
Jul 06 14:26:09 &lt;andersb&gt;       crash :)
Jul 06 14:27:33 &lt;phk&gt;   bewm
Jul 06 14:29:08 &lt;andersb&gt;       Stilt inn alle på weight 5
Jul 06 14:29:17 &lt;andersb&gt;       bortsett fra 1 som er 10
Jul 06 14:29:20 &lt;andersb&gt;       varnish er 5
Jul 06 14:29:24 &lt;phk&gt;   så giv os 20
Jul 06 14:29:51 &lt;andersb&gt;       gjort
Jul 06 14:30:58 &lt;phk&gt;   vi får kun 300 req/s
Jul 06 14:31:04 &lt;phk&gt;   Ahh der skete noget.
Jul 06 14:32:41 &lt;phk&gt;   ok, ved denne last bliver backend connections et problem, jeg har set dns fejl og connection refused
Jul 06 14:33:10 &lt;phk&gt;   dns fejl
Jul 06 14:33:21 &lt;andersb&gt;       okay, pek den mot 10.0.2.5
Jul 06 14:33:28 &lt;andersb&gt;       det er layer 2 squid cache
Jul 06 14:33:35 &lt;andersb&gt;       morro å teste det og.
Jul 06 14:33:54 &lt;phk&gt;   det gør jeg næste gang den falder
Jul 06 14:34:48 &lt;phk&gt;   jeg kunne jo også bare give leonors IP# istedet... men nu kører vi imod squid
Jul 06 14:36:05 &lt;andersb&gt;       ja, gi leonora IP det er sikkert bedre. Eller det kan jo være fint å teste mot squid og :)
Jul 06 14:39:04 &lt;phk&gt;   nu kører vi med leonora&#39;s IP#
Jul 06 14:39:33 &lt;phk&gt;   nu kører vi med leonora&#39;s *rigtige* IP#
Jul 06 14:41:20 &lt;phk&gt;   Nu er vi færdige med det her 100Mbit/s ethernet, kan vi få et til ?  :-)
Jul 06 14:41:42 &lt;andersb&gt;       lol :)
Jul 06 14:42:00 &lt;andersb&gt;       For å si det slik. Det tar ikke mange dagene før Gig switch er bestilt :)
Jul 06 14:43:05 &lt;phk&gt;   bewm
Jul 06 14:43:13 &lt;phk&gt;   ok, jeg synes vi skal stoppe her.
Jul 06 14:43:41 &lt;EvilDES&gt;       jepp, foredrag om 15 min
Jul 06 14:43:57 &lt;andersb&gt;       jepp
Jul 06 14:44:23 &lt;andersb&gt;       disabled server
Jul 06 14:45:29 &lt;EvilDES&gt;       dette har vært en veldig bra dag.
Jul 06 14:45:49 &lt;EvilDES&gt;       hva skal vi finne på i morgen? skifte ut hele Squid-riggen med en enkelt Varnish-boks? ;)
Jul 06 14:45:53 &lt;andersb&gt;       lol
Jul 06 14:46:15 *       EvilDES må begynne å sette i stand til foredraget
Jul 06 14:46:17 &lt;andersb&gt;       da må jeg har Gig switch. Eller så kan være bære med en HP maskin å koble rett på lastbal :)
Jul 06 14:46:22 &lt;phk&gt;   kan vi ikke nøjes med en halv varnish box ?
Jul 06 14:46:41 &lt;EvilDES&gt;       vi må ha begge halvdeler for failover
Jul 06 14:47:01 &lt;andersb&gt;       :)
Jul 06 14:47:14 &lt;andersb&gt;       kan faile tilbake til de andre.
Jul 06 14:47:25 &lt;andersb&gt;       Jeg klarer ikke holde meg hjemme.
Jul 06 14:47:33 &lt;andersb&gt;        Jeg kommer oppover om litt :)
Jul 06 14:47:39 &lt;andersb&gt;       Ringer på.
Jul 06 14:48:19 &lt;andersb&gt;       må gå en tur nå :)
Jul 06 14:48:29 *       andersb has quit (BitchX: no additives or preservatives)
Jul 06 14:49:44 &lt;EvilDES&gt;       http://www.des.no/varnish/
**** ENDING LOGGING AT Thu Jul  6 14:52:04 2006
</pre></div>
</div>
<p><em>phk</em></p>
</section>
</section>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">The first design of Varnish</a><ul>
<li><a class="reference internal" href="#the-first-varnish-design-notes">The first Varnish Design notes</a></li>
<li><a class="reference internal" href="#the-second-varnish-design-notes">The second Varnish Design notes</a></li>
<li><a class="reference internal" href="#the-third-varnish-design-notes">The third Varnish Design notes</a></li>
<li><a class="reference internal" href="#fourth-varnish-design-note">Fourth Varnish Design Note</a></li>
<li><a class="reference internal" href="#the-first-live-traffic">The first live traffic</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="thatslow.html"
                        title="previous chapter">Going fast slowly</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="10goingon50.html"
                        title="next chapter">Varnish - 10 going on 50</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../_sources/phk/firstdesign.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="10goingon50.html" title="Varnish - 10 going on 50"
             >next</a> |</li>
        <li class="right" >
          <a href="thatslow.html" title="Going fast slowly"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" >Poul-Hennings random outbursts</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">The first design of Varnish</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2010-2014, Varnish Software AS.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 4.3.2.
    </div>
  </body>
</html>